package mark.core.io;
import java.io.*;

/**
 * A FileFilter that accepts exactly those files that a given filter
 * does not.
 *
 * @author Mark Chavira
 */

public class NegatedFileFilter implements FileFilter {

  private FileFilter fPositive;

  /**
   * Initializes the filter.
   *
   * @param positive the given filter.
   */
   
  public NegatedFileFilter (FileFilter positive) {
    fPositive = positive;
  }

  /**
   * @see FileFilter
   */
    
  public boolean accept (File f) {
    return !fPositive.accept (f);
  }

}
