/* Generated By:JavaCC: Do not edit this line. ParameterParser.java */
package mark.core.parse;
import java.util.*;
import java.io.*;

/**
 * A parser that parses the following language:
 * <xmp>
 *   termPlusEOF ::= <Term> <EOF>
 *   Term        ::= ([~ \t\n\r\f] | "\\\\" | "\\(" | "\\)" | "\\ ")+
 *   Term        ::= "(" <termList> ")"
 *   termList    ::= (<Term>+)
 * </xmp>
 * To parse, call termPlusEOF (), which returns a parameter.  Following are
 * examples:
 * <xmp>
 *   "a"           -> "a".
 *   "a b c"       -> illegal; it is not a term.
 *   "(a)"         -> a one-element list containing "a".
 *   "(a (b) c)"   -> a three-element list.  The first element is "a".  The
 *                    second element is a one element list containing "b".
 *                    The third element is "c".
 *   "(a (b c))"   -> a two-element list containing "a" and a two-element
 *                    list.  The contained list contains "b" and "c".
 * </xmp>
 * @author Mark Chavira
 */

public class ParameterParser implements ParameterParserConstants {
  public static void main(String args[]) throws Exception {
    BufferedReader r =
      new BufferedReader (new InputStreamReader (System.in));
    while (true) {
      System.out.print ("Enter Expression: ");
      System.out.flush();
      String s = r.readLine ();
      if (s == null) {
        break;
      }
      try {
        ParameterParser parser =
          new ParameterParser (new StringReader (s));
        System.out.println (
          mark.core.text.Util.recursiveToString (
            parser.termPlusEof (), " "));
      } catch (ParseException x) {
        System.out.println("Exit.");
        System.exit (0);
      }
    }
  }

  final public Object termPlusEof() throws ParseException {
  Object ans;
    ans = term();
    jj_consume_token(0);
   {if (true) return ans;}
    throw new Error("Missing return statement in function");
  }

  final public Object term() throws ParseException {
  Token t;
  LinkedList l;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRIMITIVE:
      t = jj_consume_token(PRIMITIVE);
      String ans = t.image;
      ans = mark.core.text.Util.replace (ans, "\\(", "(");
      ans = mark.core.text.Util.replace (ans, "\\)", ")");
      ans = mark.core.text.Util.replace (ans, "\\ ", " ");
      {if (true) return ans;}
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
      l = termList();
      jj_consume_token(RPAREN);
     {if (true) return l;}
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public LinkedList termList() throws ParseException {
  Object o;
  LinkedList ans = new LinkedList ();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PRIMITIVE:
      case LPAREN:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
      o = term();
     ans.add (o);
    }
   {if (true) return ans;}
    throw new Error("Missing return statement in function");
  }

  public ParameterParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[2];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x180,0x180,};
   }

  public ParameterParser(java.io.InputStream stream) {
     this(stream, null);
  }
  public ParameterParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ParameterParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
  }

  public ParameterParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParameterParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
  }

  public ParameterParser(ParameterParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
  }

  public void ReInit(ParameterParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[10];
    for (int i = 0; i < 10; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 2; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 10; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
