package mark.core.rdag;
import java.util.*;

/**
 * An interface that defines how to copy a node to assist Node.copy ().
 *
 * @author Mark Chavira
 */

public interface NodeCopier {

  /**
   * Returns a copy of the given node.
   *
   * @param n the given node.
   * @param memo a map from old node to new node that is guaranteed to have
   *   mappings for all descendents of n.
   * @return the new node.
   */
  
  public Node copy (Node n, Map<Node,Node> memo) throws Exception;

}
