package mark.core.rdag;
import java.util.*;

/**
 * A comparator that compares simple nodes based on their fObject fields.
 *
 * @authro Mark Chavira
 */
 
public class SimpleNodeComparator
 implements Comparator<Node> {

  private Comparator fObjectComparator;
  
  /**
   * Initializes the comparator.
   *
   * @param c the fObject comparator.
   */
  
  public SimpleNodeComparator (Comparator c) {
    fObjectComparator = c;
  }

  /**
   * @see Comparator
   */
  
  public int compare (Node n1, Node n2) {
    return
      fObjectComparator.compare (
        ((SimpleNode)n1).fObject, ((SimpleNode)n2).fObject);
  }

}

