package mark.core.shell;

/**
 * A marker interface for classes that can be specified at the command line.
 * Each implementing class must meet exactly one of the following
 * requirements:
 * <ul>
 * <li> Be an enumeration.
 * <li> Implement mark.core.util.Singleton.
 * <li> Implement public static Object create (Object[] mandated, Object[] cli)
 * </ul>
 *
 * @author Mark Chavira
 */

public interface CliObject {}
