package mark.core.util;

/**
 * A marker interface for classes that are not enumerations and that conform
 * to the singleton design pattern.  A class C that implements this interface
 * must have a private constructor and instantiate one or more public objects
 * of type C on startup and disallow creation of objects of type C otherwise.
 * If there is only one object, then the instance must be called "INSTANCE".
 * Otherwise, the objects may be called anything.
 *
 * @author Mark Chavira
 */

public interface Singleton {}

