package mark.inf.cnf;
import java.util.*;
import java.io.*;

/**
 * A cnf parser that reads dimacs.
 *
 * @author Mark Chavira
 */
 
public enum CnfrDimacs implements Cnfr {
  
  /**
   * The singleton instance.
   */
  
  INSTANCE;
  
  private class Helper extends mark.inf.parse.AbstractDimacsCnfParser {
    private mark.inf.cnf.Cnf fCnf;
    private int fNumClausesFinished;
    private ArrayList<Integer> fCurrentClause;
    public Helper (Reader r) {super (r);}
    protected void finishHeader (
     int numVars, int numClauses) throws Exception {
      fCnf = new mark.inf.cnf.Cnf ();
      fCnf.fNumVars = numVars;
      fCnf.fClauses = new int[numClauses][];
      fNumClausesFinished = 0;
      fCurrentClause = new ArrayList<Integer> ();
    }
    protected void finishLiteral (int l) throws Exception {
      fCurrentClause.add (l);
    }
    protected void finishClause () throws Exception {
      fCnf.fClauses[fNumClausesFinished] = new int[fCurrentClause.size ()];
      for (int i = 0; i < fCurrentClause.size (); i++) {
        fCnf.fClauses[fNumClausesFinished][i] = fCurrentClause.get (i);
      }
      fNumClausesFinished++;
      fCurrentClause.clear ();
    }
  }
  
  /**
   * @see Cnfr
   */
  
  public Cnf cnf (Reader r) throws Exception {
    Helper h = new Helper (r);
    h.parse ();
    return h.fCnf;
  }

}
