package mark.inf.eo;

/**
 * The result produced by an elimination order algorithm.  This type is
 * a generic so that the result can be repackaged with a different order
 * type.  Specifically, a list of the higher-level node representation.
 * 
 * @author chavira
 */

public class Result<OrderType> {

  /**
   * The order.
   */
  
  public OrderType fOrder;
  
  /**
   * The log maximum cluster size.
   */
  
  public double fLog2MaxCluster;
  
  /**
   * The score.
   */
  
  public Comparable fScore;
  
  /**
   * The constructor.
   */
  
  public Result (OrderType o, double log2MaxCluster, Comparable score) {
    fOrder = o;
    fLog2MaxCluster = log2MaxCluster;
    fScore = score;
  }
  
  /**
   * Another constructor.
   */
  
  public Result (Result r, OrderType o) {
    fOrder = o;
    fLog2MaxCluster = r.fLog2MaxCluster;
    fScore = r.fScore;
  }
  
}
