package mark.inf.eo;

/**
 * A scoring strategy where the score is the log_2 of the size of the
 * maximum cluster.
 * <p>
 * This class conforms to the singleton design pattern.
 * <p>
 * This class conforms to the immutable design pattern.
 * 
 * @author Mark Chavira
 */

public enum SsMaxClusterSize implements ScoringStrategy {

  /**
   * The singleton instance.
   */
  
  INSTANCE;
  
  /**
   * @see ScoringStrategy
   */
  
  public Comparable startOverWithNewPrefix (int[] prefix, double log2MaxCluster) {
    return Double.valueOf (log2MaxCluster);
  }

  /**
   * @see ScoringStrategy
   */

  public void revertToPrefix () {}

  /**
   * @see ScoringStrategy
   */

  public Comparable addVar (
   int[] prefix, int prefixLength, double log2MaxCluster) {
    return Double.valueOf (log2MaxCluster);
  }
  
  /**
   * @see ScoringStrategy
   */
  
  public Comparable combineAtEnd (double log2MaxCluster) {
    return Double.valueOf (log2MaxCluster);
  }

}
