package mark.inf.gate;

/**
 * An enumerated type describing logic gate types.
 *
 * @author Mark Chavira
 */
 
public enum GateType {

  /**
   * A constant identifying a gate as constant low.
   */
  
  LOW,
  
  /**
   * A constant identifying a gate as constant high.
   */
  
  HIGH,
  
  /**
   * A constant identifying a gate as an input.
   */

  INPUT,

  /**
   * A constant identifying a gate as an AND gate.
   */

  AND,

  /**
   * A constant identifying a gate as a NAND gate.
   */

  NAND,

  /**
   * A constant identifying a gate as an OR gate.
   */

  OR,

  /**
   * A constant identifying a gate as a NOR gate.
   */

  NOR,

  /**
   * A constant identifying a gate as an XOR gate.
   */

  XOR,

  /**
   * A constant identifying a gate as an XNOR gate.
   */

  XNOR,

  /**
   * A constant identifying a gate as an BUFF gate.
   */

  BUFF,

  /**
   * A constant identifying a gate as a NOT gate.
   */

  NOT,

  /**
   * A constant identifying a gate as a FROM gate.
   */

  FROM

}
