package mark.inf.wcnf;
import java.util.*;
import java.io.*;

public enum WCnfrDimacs implements WCnfr {
  
  /**
   * The singleton instance.
   */
  
  INSTANCE;
  
  /**
   * @see WCnfr
   */
  
  public WCnf wcnf (Reader r) throws Exception {

    WCnf wcnf = new WCnf();
    BufferedReader br = new BufferedReader(r);

    StringTokenizer st;
    String line;
    String token;
    int i;
    ArrayList<Integer> currentClause = new ArrayList<Integer>();

    while ((line = br.readLine()) != null) {
      st = new StringTokenizer(line);
      if (st.hasMoreTokens()) {
        token = st.nextToken();
        if (token.equals("c")) {
          continue;
        } else if (token.equals("p")) {
          st.nextToken();
          token = st.nextToken();
	  wcnf.fNumVars = Integer.parseInt(token);
          token = st.nextToken();
	  i = Integer.parseInt(token);
	  wcnf.fClauses = new int[i][];
	  wcnf.fWeights = new double[i];
          break;
        }
      }
    }

    i = 0;
    while ((line = br.readLine()) != null) {
      st = new StringTokenizer(line);
      if (st.hasMoreTokens()) {
        token = st.nextToken();
	if (token.equals("c")) {
	  continue;
	} else {
	  wcnf.fWeights[i] = Double.parseDouble(token);
          while (st.hasMoreTokens()) {
            token = st.nextToken();
            if (!token.equals("0")) {
              currentClause.add(Integer.parseInt(token));
            } else {
	      break;
	    }
          }
	  wcnf.fClauses[i] = new int[currentClause.size()];
          for (int j = 0; j < currentClause.size(); j++) {
            wcnf.fClauses[i][j] = currentClause.get(j);
          }
	  currentClause.clear();
          i++;
	}
      }
    }

    return wcnf;
  }

}
