package mark.reason.flt;
import java.util.*;

/**
 * An interface for a class that inputs a set of potentials and outputs
 * outputs another.
 * <p>
 * This class participates in a command-line-object pattern:
 * <ul>
 * <li> This class fills the base role.
 * <li> Various classes fill the concrete class role.
 * </ul>
 * This class specifies no mandated parameters.
 *
 * @author Mark Chavira
 */

public interface Flt {

  /**
   * Returns a set of potentials that is the result of applying some
   * operation to the given evidence and given set of potnetials.  On
   * exit, the filter has the option of adding to the evidence.
   *
   * @param r a random generator.
   * @param pots the given potentials.
   * @param evidence the given evidence.
   * @return the result.
   */
  
  HashSet<mark.reason.net.Pot> filter (
   Random r, Set<mark.reason.net.Pot> pots) throws Exception;

}
