package mark.reason.flt;
import java.util.*;

/**
 * A filter that returns all constant potentials.
 * <p>
 * This class participates in a cliObject design pattern.  This class accepts
 * no cli parameters.
 *
 * @author Mark Chavira
 */

public enum FltConstants implements Flt, mark.core.shell.CliObject {

  /**
   * The singleton instance.
   */
  
  INSTANCE;  
  
  /**
   * Returns all constant potentials from the given set of potentials.
   * 
   * @param potentials the given potentials.
   * @return the potentials over a single variable.
   */
  
  public static HashSet<mark.reason.net.Pot> constants (
   Collection<mark.reason.net.Pot> potentials) {
    HashSet<mark.reason.net.Pot> ans = new HashSet<mark.reason.net.Pot> ();
    for (mark.reason.net.Pot d : potentials) {
      if (d.variables ().size () == 0) {
        ans.add (d);
      }
    }
    return ans;
  }

  /**
   * @see Filter
   */

  public HashSet<mark.reason.net.Pot> filter (
   Random r, Set<mark.reason.net.Pot> pots) throws Exception {
    return constants (pots);
  }

}
