package mark.reason.flt;
import java.util.*;

/**
 * A filter that converts to tables and then normalizes each potential on
 * its last variable.
 * <p>
 * This class participates in a cliObject design pattern.  This class accepts
 * no cli parameters.
 *
 * @author Mark Chavira
 */

public enum FltNormalizeLast implements Flt, mark.core.shell.CliObject {

  /**
   * The singleton instance.
   */
  
  INSTANCE;

  /**
   * Normalizes the last variable of the given potentials.
   *
   * @param distribtuions the given distribtuions.
   * @return the new potentials.
   */
  
  public static HashSet<mark.reason.net.Pot> normalizeLastVar (
   Set<mark.reason.net.Pot> potentials) throws Exception {
    HashSet<mark.reason.net.Pot> ans = new HashSet<mark.reason.net.Pot> ();
    for (mark.reason.net.Pot p : potentials) {
      ans.add (p.normalizeLast ());
    }
    return ans;
  }

  /**
   * @see Filter
   */

  public HashSet<mark.reason.net.Pot> filter (
   Random r, Set<mark.reason.net.Pot> pots) throws Exception {
    return normalizeLastVar (pots);
  }

}
