package mark.reason.inf;
import java.util.*;
import mark.reason.core.*;

/**
 * A base class for an rdag that implement propositional logic theory.
 * <p>
 * This class conforms to the immutable design pattern.
 *
 * @author Mark Chavira
 */

public abstract class NodeTheory
 extends mark.core.rdag.Node implements Theory {

  //=========================================================================
  // @see Theory:
  //=========================================================================

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Set<Var> variables () throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public boolean consistent () throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public boolean valid () throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * Returns whether the given world is a model of the theory.
   *
   * @param w the world.
   * @return whether the world is a model.
   */
  
  public boolean modelTest (Map<Var,Double> w)
   throws Exception {
    throw new Exception ("This method not implemented.");
  }
  
  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Map modelFind () throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public boolean implicant (Map pw) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public boolean entails (
   Theory rhs) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public boolean equivalent (
   Theory rhs) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public java.math.BigInteger modelCount () throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory conjoin (Theory rhs) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory disjoin (Theory rhs) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory negate () throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory condition (Map pw) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory eQuantify (Set v) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory aQuantify (Set v) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory rename (Map v) throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public int minimumCardinality () throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */
  
  public Theory minimizeCardinality ()
   throws Exception {
    throw new Exception ("This method not implemented.");
  }

  /**
   * @see Theory
   * <p>
   * This method is not implmented!
   */

  public void modelEnumerate (Pwp p)
   throws Exception {
    throw new Exception ("This method not implemented.");
  }

}
