package mark.reason.net;
import java.util.*;

/**
 * An interface for classes that compute an order for a set of potentials.
 * We utilize a new interface instead of just using java.util.Comparator,
 * because the comparator is too myopic, looking only at a pair of objects
 * at a time.  It is not capable of, for example, producing a topological
 * order.
 *
 * @author Mark Chavira
 */

public interface PotSorter {

  /**
   * Returns an ordering on the given set of potnetials.
   *
   * @param potentials the given set of potentials.
   * @return the order.
   */
  
  public ArrayList<Pot> sort (Set<Pot> pots) throws Exception;

}
