package mark.reason.plg;

/**
 * A base class for a Node that has no children.
 * <p>
 * This class conforms to the immutable design pattern.
 *
 * @author Mark Chavira
 */
 
public abstract class NodeLeaf extends Node {

  //=========================================================================
  // Node Methods:
  //=========================================================================

  /**
   * @see Node
   */
  
  public Node nthCastedChild (int n) {
    return null;
  }
  
  //=========================================================================
  // Graph Methods:
  //=========================================================================
  
  /**
   * @see Node
   */
  
  public Node clone (Node[] children) {
    return this;
  }

  /**
   * @see Node
   */

  public String toPrefixString () {
    return toInfixString ();
  }

  /**
   * @see Node
   */

  public String toInfixString () {
    return label ();
  }

  /**
   * @see Node
   */

  protected Node simplifyConnectivesHelper (Node[] ch) {
    return this;
  }

  /**
   * @see Node
   */

  protected Node notAndOrPlgHelper (Node[] ch) throws Exception {
    return this;
  }

}
