package mark.reason.plg;
import java.util.*;

/**
 * A true node in a plg.
 * <p>
 * This class conforms to the immutable design pattern.
 * <p>
 * This class conforms to the singleton design pattern.
 *
 * @author Mark Chavira
 */

public class NodeTrue extends NodeLeaf implements mark.core.util.Singleton {
  
  private NodeTrue () {}

  /**
   * The singleton instance.
   */

  public static NodeTrue INSTANCE = new NodeTrue ();
  
  //=========================================================================
  // Node Methods:
  //=========================================================================

  /**
   * @see mark.core.plg.Node
   */

  public String label () {
    return "true";
  }

  /**
   * @see Node
   */
  
  protected int computeHash () {
    return Boolean.TRUE.hashCode ();
  }

  //=========================================================================
  // Graph Methods:
  //=========================================================================

  /**
   * @see Node
   */

  protected boolean modelTestHelper (boolean[] ch, Map w) {
    return true;
  }

  /**
   * @see Node
   */

  protected Node conditionHelper (Node[] ch, Map pw) {
    return this;
  }

  /**
   * @see Node
   */

  protected Node renameHelper (Node[] ch, Map v) {
    return this;
  }

  /**
   * @see Node
   */

  protected Node reduceHelper (Node[] ch) {
    return this;
  }

}
