package mark.reason.plg;
import java.io.*;
import mark.reason.core.*;

/**
 * An interface for a parser that converts its input into a plg.
 * <p>
 * This class participates in a command-line-object (this,<various>) pattern.
 * This class specifies no mandated parameters:
 *
 * @author Mark Chavira
 */

public interface Plgr {

  /**
   * Parses the text in the given reader using the given variable table,
   * closes the given reader, and returns the resulting plg and resulting
   * variable table.
   *
   * @param r the given reader.
   * @param vt the given variable table; if null, one will be created.
   * @return (plg, vt) where plg is the resulting plg and vt is the resulting
   *   variable table.
   */

  mark.core.util.Pair<mark.reason.plg.Node,VariableTable> parse (
   Reader r, VariableTable vt) throws Exception;
  
}
