package mark.reason.query;
import java.util.*;
import mark.reason.core.*;

/**
 * An interface for an object that generates evidence streams for a bn.
 * <p>
 * This class participates in a command-line-object pattern:
 * <ul>
 * <li> This class fills the base role.
 * <li> Various classes fill the concrete class role.
 * </ul>
 * This class specifies no mandated parameters.
 *
 * @author Mark Chavira
 */

public interface Eg {

  /**
   * Generates rounds of evience for the given potentials.
   *
   * @param r the random generator.
   * @param pots the given potentials.
   * @param evidenceVariables identifies the evidence variables.
   * @param numRounds the number of rounds.
   * @return the evidence.
   */

  public ArrayList<HashMap<Var,Double>> generate (
   Random r, Set<mark.reason.net.Pot> pots,
   Set<Var> evidenceVariables, int numRounds)
   throws Exception;

}
