package mark.reason.struct;
import java.util.*;
import mark.reason.core.*;

/**
 * An interface for a class that creates a d-tree for a bn.  The d-tree will
 * have nodes of type mark.core.rdag.SimpleNode.  A leaf will have fObject
 * set to the corresponding potential.
 * <p>
 * This class participates in a command-line-object pattern:
 * <ul>
 * <li> This class fills the base role.
 * <li> Various classes fill the concrete class role.
 * </ul>
 * This class specifies no mandated parameters.
 *
 * @author Mark Chavira
 */

public interface Dtg {

  /**
   * Returns a dtree for the given set of scopes.
   *
   * @param r a random number generator.
   * @param scopes the given set of scopes.
   * @return the dtree.
   */
  
  public mark.core.rdag.Dtree<Scope> generate (
   Random r, Set<? extends Scope> scopes) throws Exception;

}
